package complete;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;

import adles2.SecondComponentInterface;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// get factory to instantiate the component from ADL 
			Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			// the has table is used to set up the context
			Map<String, Object> context = new HashMap<String, Object>();

			Component composite = (Component) f.newComponent("complete.adl.Composite", context);
			System.out.println(":: Composite Component created ...");

			Fractal.getLifeCycleController(composite).startFc();
			System.out.println(":: Component started ...");


			MasterComponentInterface sc = ((MasterComponentInterface) composite.getFcInterface("outer-component-interface"));

			List<Integer> params = new ArrayList<Integer>();
			for(int i=0; i<2; i++)
				params.add(new Integer(i));

			System.err.print(":: list of params is = <");
			Iterator<Integer> it = params.iterator();
			while(it.hasNext()) 
				System.err.print(it.next()+":");
			System.err.println(">");

			List<Integer> res = sc.doWork(params);
			
			System.err.println(":: computed results with multicast nodes ..."+res);
			Iterator<Integer> itres = res.iterator();
			while(itres.hasNext()) {
				System.err.println(":: got result ->> "+itres.next());
			}
			System.exit(0);

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}

	}

}
